import { getStorage, setStorage, getVisitorId, setCookie, getCookie, guid } from '@/uilts/help'
import { getChromeStorage, setChromeStorage } from '@/uilts/chromeExtension.js'
import { pageUrl } from "@/http/configAPI.js"

// 根据提示dom 跳转到推文详情页面
export const jumpTwitterDetailByAlert = () => {
  let num = 10
  let timer = setInterval(() => {
    if (num <= 0) {
      clearInterval(timer)
      return
    }
    let alert = document.querySelector('div[role=alert]')
    if (alert) {
      let a = alert.querySelector('a')
      if (a) {
        clearInterval(timer)
        a.click()
      }
    }
    num--
  }, 500)
}

export const showEditTweet = (callback) => {
  let bigBtn = document.querySelector('a[data-testid="SideNav_NewTweet_Button"]');
  if (bigBtn) {
    bigBtn.click();
  } else {
    let smallBtn = document.querySelector('a[href="/compose/tweet"]')
    smallBtn && smallBtn.click();
  }
  let num = 10
  let timer = setInterval(() => {
    if (num <= 0) {
      clearInterval(timer)
      return
    }
    let inputEle = document.querySelector('div[contenteditable="true"]');
    if (inputEle) {
      clearInterval(timer)
      callback && callback()
    }
    num--
  }, 500);
}

export const addFIdIframe = (cb) => {
  let fidIframe = document.getElementById('denet-fid-iframe');
  if(!fidIframe) {
    let iframe = document.createElement('iframe');
    iframe.src = `${pageUrl}/getFId`
    iframe.id = 'denet-fid-iframe'
    iframe.style.cssText = 'display:none;'
    document.querySelector('body').appendChild(iframe);
    cb && cb(iframe);
  }
};

const deviceStorageParams = {
  name: 'de_net_device_id_1'
}

export const setFId = async (params) => {
  let id = ''
  if(params && params.data && params.data.id) {
    id = `p_${params.data.id}`;
  } else {
    let res = await getVisitorId();
    id = res && res.visitorId ? `c_${res.visitorId}` : '';
  }
  setStorage(deviceStorageParams.name, id);

  let deviceInfo = await getChromeStorage('deviceInfo') || null;
  if(deviceInfo) {
    setChromeStorage({ 'deviceInfo': JSON.stringify({...deviceInfo, deviceId1: id}) });
  } else {
    setChromeStorage({ 'deviceInfo': JSON.stringify({ deviceId1: id}) });
  }
};

export const setDeviceInfo = async () => {
  const deviceCookieParams = {
    url: 'https://twitter.com/',
    name: 'de_net_device_id_2'
  }

  let deviceInfo = {
    deviceId1: '',
    deviceId2: ''
  }

  let storageDeviceInfo = getStorage(deviceStorageParams.name);
  if (!storageDeviceInfo) {
    let fidRes = await getChromeStorage('fid') || {};
    if(fidRes.fid) {
      deviceInfo.deviceId1 = `p_${fidRes.fid}`;
      setStorage(deviceStorageParams.name, `p_${fidRes.fid}`);
    } else {
      addFIdIframe()
    }
  } else {
    deviceInfo.deviceId1 = storageDeviceInfo;
  }

  let cookieDeviceInfo = getCookie(deviceCookieParams.name);
  if (!cookieDeviceInfo) {
    let rid = guid();
    setCookie(deviceCookieParams.name, rid, 600);
    deviceInfo.deviceId2 = rid;
  } else {
    deviceInfo.deviceId2 = cookieDeviceInfo;
  }

  let cacheDeviceInfo = await getChromeStorage('deviceInfo') || null;
  if(cacheDeviceInfo) {
    setChromeStorage({ 'deviceInfo': JSON.stringify({
      ...cacheDeviceInfo,
      deviceId2: deviceInfo.deviceId2
    }) });
  } else {
    setChromeStorage({ 'deviceInfo': JSON.stringify(deviceInfo) });
  }
}
